;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;     Fast ROM v2.1
;;	    by
;;     wiiqwertyuiop
;;
;; Note: You can't expand your ROM past 4MB!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Defines:

!Freespace = $318000  		; Freespace. should be fine like this. (unless Hyrule Magic uses it, in which case change this)

!BankSpace = $0089C2 		; Freespace in bank 00. This should be fine.

;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;header				; If you ROM has a header remove the ";" in front of it
lorom

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Code below
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

org $808016			;\ Enable Fast ROM
JML MainCode			;/

org !Freespace|$800000

MainCode:
LDA #$01			;\ Enable fast ROM
STA $420D			;/
LDA #$80			;\ Restore old code
STA $2100			;/	
PHA				;\ Set DBR to fastrom area
PLB				;/
JML $80801B			; Return

org !BankSpace|$800000
JML $8080C9			;Jump to FastROM NMI


JML $8082D8			;Jump to FastROM IRQ

org $80FFEA			;\
dw !BankSpace&$FFFF		; |
				; | Modify internal ROM header so NMI and IRQ run faster
org $80FFEE			; |
dw !BankSpace+$0004&$FFFF	;/

incsrc JSL.asm	; Change all JSL's to fastrom area
incsrc JML.asm	; Change all JML's to fastrom area
incsrc tables.asm	; Change all dl's and some tables to fastrom area

;; Done

org $80FFD5			;\ ROM is now fast ROM
db $30				;/